<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
//2014-02-24 fixed encoding error

function church_admin_delete_email($email_id)
{
	global $wpdb;
	$row=$wpdb->get_row('SELECT * FROM '.CA_EBU_TBL.' WHERE email_id="'.esc_sql($email_id).'"');
	if(!empty($data->filename))$paths=maybe_unserialize($data->filename);
	if(!empty($paths)){foreach($paths AS $key=>$value) unlink($value);}
	$wpdb->query('DELETE FROM '.CA_EBU_TBL.' WHERE email_id="'.esc_sql($email_id).'"');
	echo'<div class="updated fade">'.__('Email deleted','church-admin').'</div>';
	church_admin_email_list();
}
/**
 * Church Email list
 *
 * Author:     Andy Moyle
 * Author URI: http://www.churchadminplugin.com
 *
 * 
 */
function church_admin_email_list()
{
	global $wpdb;
	$items=$wpdb->get_var('SELECT COUNT(*) FROM '.CA_EBU_TBL.' WHERE recipients!=""' );
	require_once(plugin_dir_path(dirname(__FILE__)).'includes/pagination.class.php');
    if($items > 0)
    {
	
	$p = new pagination;
	$p->items($items);
	$p->limit(get_option('church_admin_page_limit')); // Limit entries per page
	$p->target("admin.php?page=church_admin/index.php&tab=communications&action=email_list");
	if(!isset($p->paging))$p->paging=1; 
	if(!isset($_GET[$p->paging]))$_GET[$p->paging]=1;
	$p->currentPage((int)$_GET[$p->paging]); // Gets and validates the current page
	$p->calculate(); // Calculates what to show
	$p->parameterName('paging');
	$p->adjacents(1); //No. of page away from the current page
	if(!isset($_GET['paging']))
	{
	    $p->page = 1;
	}
	else
	{
	    $p->page = intval($_GET['paging']);
	}
        //Query for limit paging
	$limit = esc_sql("LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit);
    $result=$wpdb->get_results('SELECT * FROM '.CA_EBU_TBL.' WHERE recipients!="" ORDER BY send_date DESC '.$limit );
	if(!empty($result))
	{
		echo'<h2>'.__('Sent Emails','church-admin').'</h2><table class="widefat striped"><thead><tr><th>'.__('Delete','church-admin').'</th><th>'.__('Date','church-admin').'</th><th>'.__('Number of recipients','church-admin').'</th><th>'.__('Subject','church-admin').'</th><th>'.__('Excerpt','church-admin').'</th><th>'.__('Resend','church-admin').'?</th><th>'.__('Resend to new recipients','church-admin').'</th><th>'.__('Edit and resend','church-admin').'</th></tr></thead><tfoot><tr><th>'.__('Delete','church-admin').'</th><th>'.__('Date','church-admin').'</th><th>'.__('Number of recipients','church-admin').'</th><th>'.__('Subject','church-admin').'</th><th>'.__('Excerpt','church-admin').'</th><th>'.__('Resend','church-admin').'?</th><th>'.__('Resend to new recipients','church-admin').'</th><th>'.__('Edit and resend','church-admin').'</th></tr></tfoot><tbody>';
		foreach($result AS $row)
		{
			$startsAt = strpos($row->message, "<!--salutation-->") + strlen("{FINDME}");
			$endsAt = strpos($row->message, "<!--News,events-->", $startsAt);
			$message = strip_tags(substr($row->message, $startsAt+17, $endsAt - $startsAt));
			$message=substr($message,0,500);
			$delete='<a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&tab=communications&action=delete_email&email_id='.intval($row->email_id),'delete_email').'">Delete</a>';
			$resend='<a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&tab=communications&action=resend_email&email_id='.intval($row->email_id),'resend_email').'">Resend to previous recipients</a>';
			$new='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&tab=communications&action=resend_new&email_id='.intval($row->email_id),'resend_new').'">'.__('Resend to new recipients','church-admin').'</a>';
			$reedit='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&tab=communications&action=edit_resend&email_id='.intval($row->email_id),'resend_new').'">'.__('Edit and send','church-admin').'</a>';
			
			echo'<tr><td>'.$delete.'</td><td>'.mysql2date(get_option('date_format'),$row->send_date).'</td><td>'.count(maybe_unserialize($row->recipients)).'</td><td>'.$row->subject.'</td><td>'.$message.'</td><td>'.$resend.'</td><td>'.$new.'</td><td>'.$reedit.'</td></tr>';
		}
	}
	}
}
/**
 * Send email function
 *
 * Author:     Andy Moyle
 * Author URI: http://www.churchadminplugin.com
 *
 * 
 */
function church_admin_send_email($email_id=NULL)
{
	global $wpdb;
	$member_type=church_admin_member_type_array();
	$gender=get_option('church_admin_gender');
	
	if(!empty($email_id))$data=$wpdb->get_row('SELECT * FROM '.CA_EBU_TBL.' WHERE email_id="'.esc_sql($email_id).'"');
	if(!empty($_POST['send-email']))
	{
		
		//handle uploaded attachments
		$upload_dir = wp_upload_dir();
		$attachments=array();
		if  ($_FILES['userfile1']['size']>0)
		{
			$attachments['1'] = $upload_dir['basedir'].'/church-admin-cache/'.$_FILES['userfile1']['name'];
			$tmpName  = $_FILES['userfile1']['tmp_name'];
			move_uploaded_file($tmpName,$attachments['1']);
		}
		if  ($_FILES['userfile2']['size']>0)
		{
			$attachments['2'] = $upload_dir['basedir'].'/church-admin-cache/'.$_FILES['userfile2']['name'];
			$tmpName  = $_FILES['userfile2']['tmp_name'];
			move_uploaded_file($tmpName,$attachments['2']);
		}
		if  ($_FILES['userfile3']['size']>0)
		{
			$attachments['3'] = $upload_dir['basedir'].'/church-admin-cache/'.$_FILES['userfile3']['name'];
			$tmpName  = $_FILES['userfile3']['tmp_name'];
			move_uploaded_file($tmpName,$attachments['3']);
		}

		//handle template & message
		$message=file_get_contents(plugin_dir_path(dirname(__FILE__)).'includes/email_template.html');
		$entered_message=stripslashes(mb_convert_encoding(nl2br($_POST['message']), 'HTML-ENTITIES', 'UTF-8'));
		$message=str_replace('[intro]',$entered_message,$message);
		//sort image floating
		$message=str_replace('class="alignleft','style="float:left;margin:5px;" class="',$message);
		$message=str_replace('class="alignright','style="float:right;margin:5px;" class="',$message);
		$message=str_replace('class="aligncenter','style="  display: block;  margin-left: auto;  margin-right: auto;" class="',$message);
		$message=str_replace('<ol>','<ol style="margin-left:5px;">',$message);
		$message=str_replace('<ul>','<ul style="margin-left:5px;">',$message);
		$message=str_replace('[subject]',$_POST['subject'],$message);//add subject
		if(get_option('church_admin_feedburner'))
		{
			$RSS='&nbsp;<a href="http://feedburner.google.com/fb/a/mailverify?uri='.get_option('church_admin_feedburner').'&amp;loc=en_US">Subscribe to '.get_option('blogname').' blog by Email</a>';
		}
		$message=str_replace('[RSS]',$RSS,$message);
		//twitter url
		if(get_option('church_admin_twitter')){$twitter='<a href="http://twitter.com/#!/'.get_option('church_admin_twitter').'" style="text_decoration:none" title="Follow us on Twitter">Twitter</a>&nbsp; ';}else{$twitter='';}
		$message=str_replace('[TWITTER]',$twitter,$message);
		//facebook url
		if(get_option('church_admin_facebook')){$facebook='<a href="'.get_option('church_admin_facebook').'" style="text_decoration:none" title="Follow us on Facebook">Facebook</a> &nbsp;';}else{$facebook='';}
		$message=str_replace('[FACEBOOK]',$facebook,$message);
		$message=str_replace('[BLOGINFO]','<a href="'.get_bloginfo('url').'">'.get_bloginfo('url').'</a>',$message);
		$message=str_replace('[HEADER_IMAGE]','<img class="header_image" src="'.get_option('church_admin_email_image').'" alt="" >',$message);
		//copyright year
		$message=str_replace('[year]',date('Y'),$message);
		$filename='Email-'.date('Y-m-d-H-i-s').'.html';
		$message=str_replace('[cache]','<p style="font-size:smaller;text-align:center;margin:0 auto;">'.__('Having trouble reading this?','church-admin').' - <a href="'.content_url('/uploads/church-admin-cache/'.$filename).'">'.__('view in your web browser','church-admin').'</a></p>',$message);
		$handle=fopen($upload_dir['basedir'].'/church-admin-cache/'.$filename,"w")OR DIE("Couldn't open");
		fwrite($handle,$message);  
		fclose($handle);
		$sqlsafe['message']=esc_sql($message);//make message sqlsafe!
		//save build message
		$email_id=$wpdb->get_var('SELECT email_id FROM '.CA_EBU_TBL.' WHERE subject="'.esc_sql(stripslashes($_POST['subject'])).'" AND message="'.esc_sql($message).'" AND from_email="'.esc_sql(stripslashes($_POST['from_email'])).'" AND from_name="'.esc_sql(stripslashes($_POST['from_name'])).'" AND filename="'.esc_sql(maybe_serialize($attachments)).'"');
		if($email_id)
		{//update
			$wpdb->query('UPDATE '.CA_EBU_TBL.' SET subject="'.esc_sql(stripslashes($_POST['subject'])).'",message="'.esc_sql($message).'", from_email="'.esc_sql(stripslashes($_POST['from_email'])).'" ,from_name="'.esc_sql(stripslashes($_POST['from_name'])).'",filename="'.esc_sql(maybe_serialize($attachments)).'" WHERE email_id="'.esc_sql($email_id).'"');
		}//end update
		else
		{//insert
			$sql='INSERT INTO '.CA_EBU_TBL.' (subject,message,from_email,from_name,send_date,filename,content) VALUES("'.esc_sql(stripslashes($_POST['subject'])).'","'.esc_sql($message).'","'.esc_sql(stripslashes($_POST['from_email'])).'","'.esc_sql(stripslashes($_POST['from_name'])).'","'.date('Y-m-d').'","'.esc_sql(maybe_serialize($attachments)).'","'.esc_sql($entered_message).'")';
			$wpdb->query($sql);
			$email_id=$wpdb->insert_id;
		}//insert    
		//when to send!
		$schedule=NULL;
		if(!empty($_POST['send_date']))
		{
			$check=church_admin_dateCheck($_POST['send_date'], 5000);
			if($check){$schedule=esc_sql($_POST['send_date']);}
		}
		if(!empty($schedule))
		{
			//set up wp_cron
			if( !wp_next_scheduled('church_admin_bulk_email'))wp_schedule_event(time(), 'hourly', 'church_admin_bulk_email');
		}
		//find recipients
		switch($_POST['type'])
		{
			case 'gender':
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND sex="'.esc_sql($_POST['sex']).'"';
			break;
			case 'site':
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND site_id="'.intval($_POST['site_id']).'"';
			break;
			case 'autocomplete': 
				$names=array();
				$ids=maybe_unserialize(church_admin_get_people_id(stripslashes($_POST['recipients'])));
				
				foreach($ids AS $value){$names[]='people_id = "'.esc_sql($value).'"';}
				$sql='SELECT  email,first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND '.implode(' OR ',$names);
				
			break;
			case 'smallgroup':
				$sql='SELECT DISTINCT a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE a.email!="" AND b.meta_type="smallgroup"  AND b.ID="'.esc_sql($_POST['group_id']).'" AND a.people_id=b.people_id';
				
			break;
			case 'member_types':
				 $w=array();
				$where='(';
				foreach($_POST['member_type'] AS $key=>$value)if(array_key_exists($value,$member_type))$w[]=' member_type_id='.$value.' ';
				$where.=implode("||",$w).')';
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND "'.$where;
			break;
			case 'individuals':
				$names=array();
				foreach ($_POST['person'] AS $value){$names[]='people_id = "'.esc_sql($value).'"';}
				$sql='SELECT  email,first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND '.implode(' OR ',$names);
			break;
			case 'ministries':
				foreach($_POST['role_id'] AS $key=>$value)$r[]='b.ID='.$value;
				$sql='SELECT  a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE b.meta_type="ministry" AND b.people_id=a.people_id AND a.email!="" AND ('.implode( " || ",$r).')' ;
			break;
			case 'hope_team':
				foreach($_POST['hope_team_id'] AS $key=>$value)$r[]='b.department_id='.$value;
				$sql='SELECT  a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE b.meta_type="hope_team" AND b.people_id=a.people_id AND a.email!="" AND ('.implode( " || ",$r).')' ;
			break;	
		}
	
		$results=$wpdb->get_results($sql);
		$emails=array();
		if($results)
		{
			foreach($results AS $row)
			{
				if(!empty($schedule)||get_option('church_admin_cron')!='immediate')
                {
					$emails[]=$row->email;
					if(QueueEmail($row->email,esc_html(stripslashes($_POST['subject'])),str_replace("<!--salutation-->",__('Dear','church-admin').' '.esc_html($row->first_name).',',$message),'',esc_html(stripslashes($_POST['from_name'])),esc_html(stripslashes($_POST['from_email'])),$attachments,$schedule)) echo'<p>'.esc_html($row->email).' queued</p>';
				}
				else
				{
					add_filter('wp_mail_content_type','church_admin_email_type');
					if(!empty($row->email))
					{
						//use native wordpress
						$emails[]=$row->email;
						$headers="From: ".esc_html(stripslashes($_POST['from_name']))." <".esc_html(stripslashes($_POST['from_email'])).">\n";
						
						if(wp_mail($row->email,esc_html(stripslashes($_POST['subject'])),str_replace('<!--salutation-->',__('Dear','church-admin').' '.$row->first_name.',',$message),$headers,$attachments)){echo'<p>'.esc_html($row->email).' sent immediately</p>';}
						else {echo $GLOBALS['phpmailer']->ErrorInfo;}
					} 
					remove_filter('wp_mail_content_type','church_admin_email_type');
				}
			}
			$wpdb->query('UPDATE '.CA_EBU_TBL.' SET recipients="'.esc_sql(maybe_serialize($emails)).'" WHERE email_id="'.esc_sql($email_id).'"');
		}else{echo '<div class="error fade">'.__('No email addresses found','church-admin').'</p>';}
		//send or queue
		
		
		
	}
	else
	{
		echo'<div class="wrap"><h2>'.__('Bulk Email','church-admin').'</h2>';
		echo'<form action="" enctype="multipart/form-data" method="post" >';
		church_admin_recipients();
		//subject
		echo'<table class="form-table">	';
		echo'<tr><th scope="row">'.__('Subject','church-admin').'</th><td><input type="text" name="subject" ';
		if(!empty($data->subject)) echo ' value="'.esc_html($data->subject).'"';
		echo'/></td></tr>';
		echo'<tr><th scope="row">'.__('From name','church-admin').'</th><td><input type="text" name="from_name"  ';
		if(!empty($data->from_name)) echo ' value="'.esc_html($data->from_name).'"';
		echo'/></td></tr>';
		echo'<tr><th scope="row">'.__('From email','church-admin').'</th><td><input type="text" name="from_email"  ';
		if(!empty($data->from_email)) echo ' value="'.esc_html($data->from_email).'"';
		echo'/></td></tr>';
		//attachments
		echo'<tr><th scope="row">'.__('Attachment','church-admin').' 1 (max 500KB):</th><td><input type="file" name="userfile1"/></td></tr>';
		echo'<tr><th scope="row">'.__('Attachment','church-admin').' 2 (max 500KB):</th><td><input type="file" name="userfile2"/></td></tr>';
		echo'<tr><th scope="row">'.__('Attachment','church-admin').' 3 (max 500KB):</th><td><input type="file" name="userfile3"/></td></tr>';
		echo'</tbody></table>';
		$content = '';
		$editor_id = 'message';
		echo'<div id="poststuff">';
		$content='';
		if(!empty($data->content))$content=$data->content;
		wp_editor($content,'message');
		echo'</div>';
		echo'<table class="form-table"><tbody>';
		echo'<tr><th scope="row">Send now </th><td><input type=checkbox id="now" name=schedule value="now" checked="checked"/></td></tr>';
		echo'<tr><th scope="row">Or schedule?</th><td><input name="send_date" id="send_date" type="text"  /></td></tr>';
		echo'<script type="text/javascript">jQuery(document).ready(function($){   $(\'#send_date\').datepicker({
            dateFormat : "'."yy-mm-dd".'", changeYear: true ,yearRange: "2015:'.date('Y',time()+60*60*24*365*10).'"
         });
		 $("#send_date").change(function(){$("#now").prop( "checked", false );});
			});</script>';
		echo'<tr><th scope="row">&nbsp;</th><td><input type="hidden" name="send-email" value="TRUE"/><input class="button-primary" type="submit" value="'.__('Send','church-admin').'"/></td></tr>';

		echo'</tbody></table></form></div>';
	}
	
}

 /**
 *
 * Recipients form element
 * 
 * @author  Andy Moyle
 * @param    
 * @return   
 * @version  0.945
 *
 * 
 * 
 */ 
function church_admin_recipients()
{
	global $wpdb;
	$member_type=church_admin_member_type_array();
	echo'<table class="form-table">';
		echo'<tr><th scope="row">'.__('Recipients','church-admin').'</th>';
		echo'<td>';
		echo __('Type in names','church-admin').'<input type="radio" class="rec-type" name="type" value="autocomplete"/><br/>';
		echo __('A small group','church-admin').'<input type="radio" name="type" value="smallgroup"/><br/>';
		echo __('Gender','church-admin').'<input type="radio" name="type" value="gender"/><br/>';
		echo __('Goes to site','church-admin').'<input type="radio" name="type" value="site"/><br/>';
		echo __('Choose individuals','church-admin').'<input type="radio" name="type" value="individuals"  /><br/>';
		echo __('Choose member types','church-admin').'<input type="radio" name="type" value="member_types"  /><br/>';
		echo __('Everyone in this ministry','church-admin').'<input type="radio" name="type" value="ministries"  /><br/>';
		echo __('A Hope Team','church-admin').'<input type="radio" name="type" value="hope_team"/><br/>';
		echo'</td></tr>';
		echo'<script>jQuery(document).ready(function($) {
			$(".ca-types").hide();
		$("input[name=type]:radio").click(function() {
			switch($(this).val())
			{
				case "autocomplete": $(".ca-types").hide();$(".autocomplete").show();break;
				case "member_types": $(".ca-types").hide();$(".member_types").show();break;
				case "smallgroup": $(".ca-types").hide();$(".smallgroup").show();break;
				case "individuals": $(".ca-types").hide();$(".individuals").show();break;
				case "ministries": $(".ca-types").hide();$(".ministries").show();break;
				case "hope_team": $(".ca-types").hide();$(".hope_team").show();break;
				case "gender": $(".ca-types").hide();$(".gender").show();break;
				case "site": $(".ca-types").hide();$(".site").show();break;
			}
		});
		});
		</script>';
		//gender
		$gender=get_option('church_admin_gender');
		
		echo'<tr class="ca-types gender" ><th scope="row">'.__('Gender','church-admin').'</th><td><select name="sex">';
		foreach($gender AS $key=>$value){echo '<option value="'.esc_html($key).'" >'.esc_html($value).'</option>';}
		echo'</select></td></tr>'."\r\n";
	
		//site
		$sites=$wpdb->get_results('SELECT venue,site_id FROM '.CA_SIT_TBL.' ORDER BY venue ASC');
		echo'<tr class="ca-types site" ><th scope="row">'.__('Site','church-admin').'</th><td><select name="site_id" id="site_id1" class="site_id">';
		foreach($sites AS $site)
		{
			echo'<option value="'.intval($site->site_id).'">'.esc_html($site->venue).'<option>';
		}
		echo'</select></td></tr>'."\r\n";
		//autocomplete
		echo'<tr class="ca-types autocomplete"><th scope=row>'.__('Type in names','church-admin').'</th><td>'.church_admin_autocomplete('recipients','friends','to','').'</td></tr>'; 
		//smallgroup
		echo'<tr class="ca-types smallgroup"><th scope=row>'.__('Choose small groups','church-admin').'</th><td>';
		echo' <select name="group_id">';
		$results=$wpdb->get_results('SELECT * FROM '.CA_SMG_TBL);
		foreach($results AS $row){echo'<option value="'.esc_html($row->id).'">'.esc_html($row->group_name).'</option>';}
		echo'</select></td></tr>';
		//individuals
		echo'<tr class="ca-types individuals"><th scope=row>'.__('Choose individuals','church-admin').'</th><td>';
		echo '<div class="clonedInput" id="input1">';
		echo'<p><select name="person[]" id="person1" class="person">';
		$results=$wpdb->get_results('SELECT CONCAT_WS(", ",last_name,first_name) AS name,people_id FROM '.CA_PEO_TBL.' WHERE email!="" AND last_name!="" AND first_name!="" ORDER BY last_name');
		foreach($results AS $row){echo '<option value="'.esc_html($row->people_id).'">'.esc_html($row->name).'</option>';}
		echo'</select></p></div>';
		echo'<p><input type="button" id="btnAdd" value="'.__('Add another person','church-admin').'" /><input type="button" id="btnDel" value="'.__('Remove person','church-admin').'" /></p>';
		echo'</td></tr>';
		//member types
		echo'<tr class="ca-types member_types"><th scope=row>'.__('Choose everyone in member type...','church-admin').'</th><td>';
		 foreach($member_type AS $key=>$value){echo'<p><label><strong>'.__('All','church-admin').' '.$value.'</strong></label><input type="checkbox" name="member_type[]" value="'.$key.'"/></p>';}
		//ministries
		echo'<tr class="ca-types ministries"><th scope=row>'.__('Choose everyone in ministry...','church-admin').'</th><td>';
		echo '<div class="roleclonedInput" id="roleinput1">';
		echo'<p><select name="role_id[]" id="roleid1" class="role_id">';
		$ministries=get_option('church_admin_departments');
		foreach($ministries AS $key=>$value){echo'<option value="'.esc_html($key).'">'.esc_html($value).'</option>';}
		echo'</select></p></div>';
		echo'<p><input type="button" id="roleadd" value="'.__('Add another ministry','church-admin').'" /><input type="button" id="roledel" value="Remove ministry" /></p>';
		echo'</td></tr>';
		//hope team
		
		//hope teams
		$result=$wpdb->get_results('SELECT * FROM '.CA_HOP_TBL);
		if(!empty($result))
		{
			echo'<tr class="ca-types hope_team"><th scope=row>'.__('Choose everyone in hope team...','church-admin').'</th><td>';
			$hope_team=array();
			foreach($result AS $row) $hope_team[$row->hope_team_id]=$row->job;
			echo '<div class="hopeclonedInput" id="hopeinput1">';
			echo'<p><select name="hope_team_id[]" id="hope_team_id" class="hope_team_id">';
			foreach($hope_team AS $key=>$value){echo'<option value="'.esc_html($key).'">'.esc_html($value).'</option>';}
			echo'</select></p></div>';
			echo'<p><input type="button" id="hopeadd" value="'.__('Add another hope team','church-admin').'" /><input type="button" id="hopedel" value="Remove hope_team" /></p></div>';
			echo'</td></tr>';
		}
		echo'</table>';
}

function getTweetUrl($url, $text)

{

$maxTitleLength = 120 ;

if (strlen($text) > $maxTitleLength) {

$text = substr($text, 0, ($maxTitleLength-3)).'...';

}

$text=str_replace('"','',$text);

$outputurl='http://twitter.com/share?wrap_links=true&amp;url='.urlencode($url).'&amp;text='.urlencode($text);

$output='<a href="http://twitter.com/share" class="twitter-share-button" data-url="'.$outputurl.'" data-text="'.$text.'" data-count="horizontal">Tweet</a>';

return $output;

}

function church_admin_resend($email_id)
{
	global $wpdb;
	$email=$wpdb->get_row('SELECT * FROM '.CA_EBU_TBL.' WHERE email_id="'.esc_sql($email_id).'"');
	
	if(!empty($email))
	{
		$addresses=maybe_unserialize($email->recipients);
		foreach($addresses AS $key=>$emailadd)
			{
				if(!empty($schedule)||get_option('church_admin_cron')!='immediate')
                {
					
					if(QueueEmail($emailadd,esc_html($email->subject),$email->message,'',$email->from_name,$email->from_email,$email->filename,$email->schedule)) echo'<p>'.esc_html($emailadd).' queued</p>';
				}
				else
				{
					add_filter('wp_mail_content_type','church_admin_email_type');
					if(!empty($emailadd))
					{
						//use native wordpress
						
						$headers="From: ".esc_html($email->from_name)." <".esc_html($email->from_email).">\n";
						
						if(wp_mail($emailadd,$email->subject,$email->message,$email->headers,$email->filename)){echo'<p>'.esc_html($emailadd).' sent immediately</p>';}
						else {echo $GLOBALS['phpmailer']->ErrorInfo;}
					} 
					remove_filter('wp_mail_content_type','church_admin_email_type');
				}
			}
	

	}
}

function church_admin_resend_new($email_id)
{
 	global $wpdb;
	echo'<h2>'.__('Resending email to new recipients','church-admin').'</h2>';
	//get the original email
	$email=$wpdb->get_row('SELECT * FROM '.CA_EBU_TBL.' WHERE email_id="'.esc_sql($email_id).'"');
	//process sending
	if(!empty($_POST['resend_new']))
	{
		
		//find recipients
		switch($_POST['type'])
		{
			case 'gender':
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND sex="'.esc_sql($_POST['sex']).'"';
			break;
			case 'site':
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND site_id="'.intval($_POST['site_id']).'"';
			break;
			case 'autocomplete': 
				$names=array();
				$ids=maybe_unserialize(church_admin_get_people_id(stripslashes($_POST['recipients'])));
				
				foreach($ids AS $value){$names[]='people_id = "'.esc_sql($value).'"';}
				$sql='SELECT  email,first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND '.implode(' OR ',$names);
				
			break;
			case 'smallgroup':
				$sql='SELECT DISTINCT a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE a.email!="" AND b.meta_type="smallgroup"  AND b.ID="'.esc_sql($_POST['group_id']).'" AND a.people_id=b.people_id';
			break;
			case 'member_types':
				 $w=array();
				$where='(';
				foreach($_POST['member_type'] AS $key=>$value)if(array_key_exists($value,$member_type))$w[]=' member_type_id='.$value.' ';
				$where.=implode("||",$w).')';
				$sql='SELECT email, first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND "'.$where;
			break;
			case 'individuals':
				$names=array();
				foreach ($_POST['person'] AS $value){$names[]='people_id = "'.esc_sql($value).'"';}
				$sql='SELECT  email,first_name FROM '.CA_PEO_TBL.' WHERE email!="" AND '.implode(' OR ',$names);
			break;
			case 'ministries':
				foreach($_POST['role_id'] AS $key=>$value)$r[]='b.ID='.$value;
				$sql='SELECT  a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE b.meta_type="ministry" AND b.people_id=a.people_id AND a.email!="" AND ('.implode( " || ",$r).')' ;
			break;
			case 'hope_team':
				foreach($_POST['hope_team_id'] AS $key=>$value)$r[]='b.ID='.$value;
				$sql='SELECT  a.email,a.first_name FROM '.CA_PEO_TBL.' a,'.CA_MET_TBL.' b WHERE b.meta_type="hope_team" AND b.people_id=a.people_id AND a.email!="" AND ('.implode( " || ",$r).')' ;
			break;	
		}
	
		$results=$wpdb->get_results($sql);
		$emails=array();
		if($results)
		{
			foreach($results AS $row)
			{
				if(get_option('church_admin_cron')!='immediate')
                {
					$emails[]=$row->email;
					if(QueueEmail($row->email,esc_html($email->subject),str_replace("<!--salutation-->",__('Dear','church-admin').' '.esc_html($row->first_name).',',$email->message),'',esc_html($email->from_name),esc_html($email->from_email),$email->attachments,$schedule)) echo'<p>'.esc_html($row->email).' queued</p>';
				}
				else
				{
					add_filter('wp_mail_content_type','church_admin_email_type');
					if(!empty($row->email))
					{
						//use native wordpress
						$emails[]=$row->email;
						$headers="From: ".esc_html($row->first_name)." <".esc_html($email->from_email).">\n";
						
						if(wp_mail($row->email,esc_html($email->subject),str_replace('<!--salutation-->',__('Dear','church-admin').' '.$row->first_name.',',$email->message),$headers,$email->attachments)){echo'<p>'.esc_html($row->email).' sent immediately</p>';}
						else {echo $GLOBALS['phpmailer']->ErrorInfo;}
					} 
					remove_filter('wp_mail_content_type','church_admin_email_type');
				}
			}
			
		}else{echo '<div class="error fade">'.__('No email addresses found','church-admin').'</p>';}
	}
	else
	{//form to choose and send
		echo'<h2>'.__('Choose recipients to resend to','church-admin').'</h2>';
		echo'<form action="" method="POST">';
		echo church_admin_recipients();
		echo'<table class="form-table"><tr><th scope="row">&nbsp;</th><td><input type="hidden" name="resend_new" value="TRUE"/><input class="button-primary" type="submit" value="'.__('Send','church-admin').'"/></td></tr>';
		echo'</tbody></table></form>';
	}
}